/* config.h
 * This file was produced by running the config.h.SH script, which
 * gets its values from config.sh, which is generally produced by
 * running Configure.
 *
 * Feel free to modify any of this as the need arises.  Note, however,
 * that running config.h.SH again will wipe out any changes you've made.
 * For a more permanent change edit config.sh and rerun config.h.SH.
 * $Id: config.h.SH,v 4.4.2.1 1991/12/01 18:05:42 sob PATCH_2 sob $
 *
 * $Log: config.h.SH,v $
 * Revision 4.4.2.1  1991/12/01  18:05:42  sob
 * Fixed problems with CTRLA flag.
 *
 * Revision 4.4  1991/09/09  20:18:23  sob
 * release 4.4
 *
 *
 * 
 */
/* This software is Copyright 1991 by Stan Barber. 
 *
 * Permission is hereby granted to copy, reproduce, redistribute or otherwise
 * use this software as long as: there is no monetary profit gained
 * specifically from the use or reproduction of this software, it is not
 * sold, rented, traded or otherwise marketed, and this copyright notice is
 * included prominently in any copy made. 
 *
 * The author make no claims as to the fitness or correctness of this software
 * for any use whatsoever, and it is provided as is. Any use of this software
 * is at the user's own risk. 
 */

/* name of the site.  May be overridden by HOSTFILE, gethostname, uname, etc. */
#define SITENAME "zhintil"
#define HOSTFILE "/etc/HOSTNAME"	/* defined if we read the hostname from a file */

/* domain name for the site */
#define OURDOMAIN "autin.tx.us"

/* name of the organization, may be a file name */
#define ORGNAME "/etc/organization"

/* ignore the ORGANIZATION environment variable */
/*#undef IGNOREORG		/**/

/* login name of news administrator, if any. */
#define NEWSADMIN "news"	/**/

/* news library, may use only ~ and %l expansion */
#define LIB "/usr/lib/news"

/* rn private library, may use ~ expansion, %x and %l */
#define RNLIB "/usr/local/lib/trn"

/* mthreads private files */
#define MTLIB "/usr/local/lib/trn"

/* location of the news spool directory, may use ~ expansion, %x and %l */
#define SPOOL "/tmp"

/* the server's spool directory if generating an NNTP trn & a local mthreads */
/*#undef SERVERSPOOL ""	/* forces local mthreads */

/* put thread files in each spool directory, unless THREAD_DIR is defined */
#define THREAD_DIR "/usr/spool/threads"	/* base directory */

/* save in subdirectories unless LONG_THREAD_NAMES & THREAD_DIR are defined */
/*#undef LONG_THREAD_NAMES		/* not for short-name systems */

/* I doubt you'd want to undefine this, but someone may */
#define USETMPTHREAD			/* use tmpthread to update threads */

/* location of the active file, may use ~ expansion, %x and %l */
#define ACTIVE ""

/* define where the active.times file is kept if we're using it */
#define ACTIVE_TIMES "nntp"	/* including name */

/* location of spooled mail */
#define MAILFILE "/usr/spool/mail/%L"

/* default shell--ok to be a slow shell like csh */
#define PREFSHELL "/bin/csh"

/* default editor */
#define DEFEDITOR "/usr/bin/vi"

/* root uid */
#define ROOTID 0

/* what is the first character of a mailbox? */
#define MBOXCHAR 'F'

/* how to cancel an article */
#define CANCEL "/usr/local/lib/news/inews -h <%h"

/* distribution groups */
#define LOCDIST   "local"
#define ORGDIST   "austin"
#define CITYDIST  "austin"
#define STATEDIST "tx"
#define CNTRYDIST "us"
#define CONTDIST  "na"

#define THREAD_INIT FALSE
#define SELECT_INIT TRUE

#define index  strchr		/* cultural */
#define rindex strrchr		/*  differences? */
/*#undef bcopy(s,d,n) memcpy((char*)d,(char*)s,(int)n)	/* Different */
/*#undef bzero(d,n)   memset((char*)d,0,(int)n)		/*  flavors. */
#define RENAME		/* is rename() a system call? */
#define FTRUNCATE	/* is ftruncate() available? */
#define USLEEP		/* do we have usleep? */
/*#undef USELECT 	/* should we use select to emulate usleep? */
#define STRFTIME	/* is strftime() available? */
#define FOUNDSIZET	/* is size_t around? */
/*#undef CHSIZE		/* is chsize() available? */
#define TZSET		/* modern timezone functions? */
/*#undef void int	/* is void to be avoided? */
#define vfork fork	/* is vfork too virtual? */
/*#undef SUNOS4		/* running SunOS 4.X? */
/*#undef EUNICE		/* no linking? */
/*#undef VMS		/* not currently used, here just in case */
/*#undef GETCWD		/* do we have getcwd()? */
#define GETWD		/* do we have getwd()? */
/*#undef SETVBUF 	/* do we have setvbuf()? */
#define SETBUFFER	/* do we have setbuffer()? */
/*#undef USENDIR 	/* include ndir.c? */
/*#undef LIBNDIR 	/* include /usr/include/ndir.h? */
#define DIRTYPE dirent
#ifndef USENDIR
#define DIRINC <dirent.h>
#endif
#define MININACT	/* include 2.10.2 optimization? */
#define PORTABLE	/* do we do extra lookups to start up? */
/*#undef PASSNAMES	/* do names come from the passwd file? */
			/*  (undef to take name from ~/.fullname) */
/*#undef BERKNAMES	/* if so, are they Berkeley format? */
			/* (that is, ":name,stuff:") */
/*#undef USGNAMES	/* or are they USG format? */
			/* (that is, ":stuff-name(stuff):") */
/*#undef WHOAMI		/* should we include whoami.h? */
/*#undef RDCHK		/* do we have rdchk()? */
#define TERMIO		/* is this a termio system? */
/*#undef TERMIOS 	/* is this a termios system? */
#define FCNTL		/* should we include fcntl.h? */
#define IOCTL		/* are ioctl args all defined in one place? */
/*#undef PTEM		/* has the ptem.h include file ? */
#define NORMSIG 	/* use signal rather than sigset? */
/*#undef SIGBLOCK	/* use sigblock and sigsetmask */
/*#undef HAVESIGHOLD	/* use sighold and sigrelse */
#define SIGRET void	/* what does signal() return? */
#define HAVETERMLIB	/* do we have termlib-style routines? */
/*#undef GETUIDGID	/* allow setuid (if possible) */
#define GETPWENT	/* should we include getpwent? */
#define INTERNET	/* does our mailer do INTERNET addressing? */
#define GETHOSTNAME	/* do we have a gethostname function? */
/*#undef DOUNAME 	/* do we have a uname function? */
/*#undef PHOSTNAME "cat /etc/HOSTNAME"	/* how to get host name with popen */
#define NORELAY 	/* 2.10.3 doesn't have Relay-Version line */
#define SERVER		/* rrn server code */
#define SERVER_FILE "/etc/nntpserver"	/* news server file */
/*#undef USESYSLOG 	/* use syslog for mthreads' log messages */
/*#undef XTHREAD 	/* get thread files via NNTP */
